#include <QFile>
#include <iostream>

int append(QString input, QFile &out, double wholeSize, int byteToCopy)
{
    QFile in(input);
    if (!in.open(QIODevice::ReadOnly|QIODevice::Unbuffered)) {
        std::cerr << "Konnte " << qPrintable(input) << " nicht lesend ffnen." << std::endl;
        return -1;
    }
    double outSize;
    while (!in.atEnd()) {
        out.write(in.read(byteToCopy));
        std::cerr << "\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b";
        outSize = out.size()/1024.0/1024.0;
        std::cerr << "Forschritt(%): " << int((outSize/wholeSize)*1000.0)/10.0;
    }
    in.close();
    return 0;
}

int main(int argc, char *argv[])
{
    if (argc < 2) {
        std::cerr << "Aufruf: binaryCopy \"Pfad zu input1\" \"Pfad zu input2\" ... \"Pfad zu inputN\" \"Pfad zu output\"" << std::endl;
        return 0;
    }
    QString output = argv[argc-1];
    QFile out(output);
    if (!out.open(QIODevice::Append|QIODevice::Unbuffered)) {
        std::cerr << "Konnte " << qPrintable(output) << " nicht im append Mode ffnen." << std::endl;
        return -1;
    }
    qint64 byteSize = 0;
    QString pathToFile;
    QFile file;
    for (int i = 1, count = argc-1; i < count; ++i) {
        pathToFile = argv[i];
        file.setFileName(pathToFile);
        byteSize += (qint64)(file.size());
    }
    double size = byteSize/1024.0/1024.0;
    int byteToCopy = 100*1024*1024;
    if (size >= 10000) {
        byteToCopy = 50*1024*1024; //50MB
    } else {
        byteToCopy = 1024*1024; //1MB
    }

    std::cerr << "Komplett zu kompierende Groesse: " << size << " MB" << std::endl;
    for (int i = 1, count = argc-1; i < count; ++i) {
        if (append(argv[i], out, size, byteToCopy) != 0) {
            std::cerr << std::endl;
            out.close();
            return -1;
        }
    }
    std::cerr << std::endl;
    out.close();
    return 0;
}
